Your search did not match any results.

JavaScript/jQuery Drawer - Top or Bottom Position

JavaScript Drawer is a dismissible or permanently visible panel that usually contains navigation elements.

To open or close the JavaScript Drawer component in this demo, click the 'Hamburger' button. Each JavaScript Drawer visibility change can adjust the layout in the following ways (see openedStateMode):

  • "push"
    The JavaScript Drawer partially displaces the view.

  • "shrink"
    The view shrinks to accommodate the JavaScript Drawer.

  • "overlap"
    The JavaScript Drawer overlaps the view.

Backend API
$(() => { $('#content').html(text); const drawer = $('#drawer').dxDrawer({ height: 400, revealMode: 'expand', position: 'top', closeOnOutsideClick: true, template() { const $list = $('<div>').addClass('panel-list'); return $list.dxList({ dataSource: navigation, }); }, }).dxDrawer('instance'); $('#toolbar').dxToolbar({ items: [{ widget: 'dxButton', location: 'before', options: { icon: 'menu', stylingMode: 'text', onClick() { drawer.toggle(); }, }, }], }); $('#opened-state-mode').dxRadioGroup({ items: ['push', 'shrink', 'overlap'], layout: 'horizontal', value: 'shrink', onValueChanged(e) { drawer.option('openedStateMode', e.value); $('#reveal-mode-option').css('visibility', e.value !== 'push' ? 'visible' : 'hidden'); }, }); $('#position-mode').dxRadioGroup({ items: ['top', 'bottom'], layout: 'horizontal', value: 'top', onValueChanged(e) { drawer.option('position', e.value); }, }); $('#reveal-mode').dxRadioGroup({ items: ['slide', 'expand'], layout: 'horizontal', value: 'expand', onValueChanged(e) { drawer.option('revealMode', e.value); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" /> <script src="js/dx.all.js?v=25.2.8"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="flex-container"> <div id="toolbar"></div> <div id="drawer"> <div id="content"> </div> </div> <div class="options"> <div class="caption">Options</div> <div class="options-container"> <div class="option"> <label>Opened state mode</label> <div id="opened-state-mode"></div> </div> <div class="option"> <label>Position</label> <div id="position-mode"></div> </div> <div id="reveal-mode-option" class="option"> <label>Reveal mode</label> <div id="reveal-mode"></div> </div> </div> </div> </div> </div> </body> </html>
.demo-container { overflow: visible; } .flex-container { display: flex; flex-direction: column; } .dx-drawer-content { display: flex; } #toolbar { background-color: var(--dx-component-color-bg); box-shadow: 0 2px 8px 0 rgba(0, 0, 0, 0.12), 0 2px 2px 0 rgba(0, 0, 0, 0.08); padding: 5px 10px; z-index: 10000; } .dx-drawer-shrink #content { overflow: hidden; transition: all 0.4s ease-out; column-width: 900px; } .dx-drawer-shrink.dx-drawer-opened #content { margin-right: -10px; } .panel-list { height: 200px; padding-top: 12px; background-color: var(--dx-color-main-bg); } .panel-list .dx-list-item { text-align: center; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); } .options-container { display: flex; align-items: center; } .caption { font-size: 18px; font-weight: 500; } .option { margin-top: 10px; display: inline-block; margin-right: 50px; } label { font-weight: bold; } #content { height: 100%; padding: 10px 20px; background-color: var(--dx-component-color-bg); } #content h2 { font-size: 26px; }
const navigation = [ { id: 1, text: 'Products' }, { id: 2, text: 'Sales' }, { id: 3, text: 'Customers' }, { id: 4, text: 'Employees' }, { id: 5, text: 'Reports' }, ]; const text = ` <h2> <b>Drawer Demo</b> </h2> <p> Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Penatibus et magnis dis parturient. Eget dolor morbi non arcu risus. Tristique magna sit amet purus gravida quis blandit. Auctor urna nunc id cursus metus aliquam eleifend mi in. Tellus orci ac auctor augue mauris augue neque gravida. Nullam vehicula ipsum a arcu. Nullam ac tortor vitae purus faucibus ornare suspendisse sed nisi. Cursus in hac habitasse platea dictumst. Egestas dui id ornare arcu. Dictumst vestibulum rhoncus est pellentesque elit ullamcorper dignissim.</p><p>Mauris rhoncus aenean vel elit scelerisque mauris pellentesque pulvinar. Neque volutpat ac tincidunt vitae semper quis lectus. Sed sed risus pretium quam vulputate dignissim suspendisse in. Urna nec tincidunt praesent semper feugiat nibh sed pulvinar. Ultricies lacus sed turpis tincidunt id aliquet risus feugiat. Amet cursus sit amet dictum sit amet justo donec enim. Vestibulum rhoncus est pellentesque elit ullamcorper. Id aliquet risus feugiat in ante metus dictum at. </p>`;

Use the radio buttons at the bottom of this demo module to try different layout modes. You can also change the JavaScript Drawer's position and revealMode properties.

Note this demo's markup. The JavaScript Drawer definition encloses the view content (the formatted text). The JavaScript Drawer's own content (navigation links) is set by the template property. Finally, the toolbar markup is separate from other elements.

To get started with the DevExtreme JavaScript Drawer component, refer to the following step-by-step tutorial: Getting Started with Navigation JavaScript Drawer.

Backend API
<template>
<div class="flex-container">
<DxToolbar
id="toolbar"
:items="toolbarContent"
/>
<DxDrawer
:opened-state-mode="selectedOpenMode"
:position="selectedPosition"
:reveal-mode="selectedRevealMode"
v-model:opened="openState"
:height="400"
:close-on-outside-click="true"
template="listMenu"
>
<template #listMenu="{ data }">
<NavigationList/>
</template>
<div
id="content"
v-html="text"
/>
</DxDrawer>
<div class="options">
<div class="caption">Options</div>
<div class="options-container">
<div class="option">
<label>Opened state mode</label>
<DxRadioGroup
v-model:value="selectedOpenMode"
:items="showModes"
layout="horizontal"
/>
</div>
<div class="option">
<label>Position</label>
<DxRadioGroup
v-model:value="selectedPosition"
:items="positionModes"
layout="horizontal"
/>
</div>
<div
v-if="selectedOpenMode !== 'push'"
class="option"
>
<label>Reveal mode</label>
<DxRadioGroup
v-model:value="selectedRevealMode"
:items="showSubmenuModes"
layout="horizontal"
/>
</div>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxDrawer, { type DxDrawerTypes } from 'devextreme-vue/drawer';
import DxRadioGroup from 'devextreme-vue/radio-group';
import DxToolbar from 'devextreme-vue/toolbar';
import NavigationList from './NavigationList.vue';
import { text } from './data.ts';
const showModes = ['push', 'shrink', 'overlap'];
const positionModes = ['top', 'bottom'];
const showSubmenuModes = ['slide', 'expand'];
const selectedOpenMode = ref<DxDrawerTypes.OpenedStateMode>('shrink');
const selectedPosition = ref<DxDrawerTypes.PanelLocation>('top');
const selectedRevealMode = ref<DxDrawerTypes.RevealMode>('expand');
const openState = ref(false);
const toolbarContent = [{
widget: 'dxButton',
location: 'before',
options: {
icon: 'menu',
stylingMode: 'text',
onClick: () => { openState.value = !openState.value; },
},
}];
</script>
<style scoped>
.demo-container {
overflow: visible;
}
.flex-container {
display: flex;
flex-direction: column;
}
.dx-drawer-content {
display: flex;
}
#toolbar {
background-color: var(--dx-component-color-bg);
box-shadow: 0 2px 8px 0 rgba(0, 0, 0, 0.12), 0 2px 2px 0 rgba(0, 0, 0, 0.08);
padding: 5px 10px;
z-index: 10000;
}
.dx-drawer-shrink #content {
overflow: hidden;
transition: all 0.4s ease-out;
column-width: 900px;
}
.dx-drawer-shrink.dx-drawer-opened #content {
margin-right: -10px;
}
.panel-list {
height: 200px;
padding-top: 12px;
background-color: var(--dx-color-main-bg);
}
.panel-list .dx-list-item {
text-align: center;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.options-container {
display: flex;
align-items: center;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
display: inline-block;
margin-right: 50px;
}
label {
font-weight: bold;
}
#content {
height: 100%;
padding: 10px 20px;
background-color: var(--dx-component-color-bg);
}
#content h2 {
font-size: 26px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export const navigation = [
{ id: 1, text: 'Products' },
{ id: 2, text: 'Sales' },
{ id: 3, text: 'Customers' },
{ id: 4, text: 'Employees' },
{ id: 5, text: 'Reports' },
];
export const text = '<h2><b>Drawer Demo</b></h2><p>Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Penatibus et magnis dis parturient. Eget dolor morbi non arcu risus. Tristique magna sit amet purus gravida quis blandit. Auctor urna nunc id cursus metus aliquam eleifend mi in. Tellus orci ac auctor augue mauris augue neque gravida. Nullam vehicula ipsum a arcu. Nullam ac tortor vitae purus faucibus ornare suspendisse sed nisi. Cursus in hac habitasse platea dictumst. Egestas dui id ornare arcu. Dictumst vestibulum rhoncus est pellentesque elit ullamcorper dignissim.</p><p>Mauris rhoncus aenean vel elit scelerisque mauris pellentesque pulvinar. Neque volutpat ac tincidunt vitae semper quis lectus. Sed sed risus pretium quam vulputate dignissim suspendisse in. Urna nec tincidunt praesent semper feugiat nibh sed pulvinar. Ultricies lacus sed turpis tincidunt id aliquet risus feugiat. Amet cursus sit amet dictum sit amet justo donec enim. Vestibulum rhoncus est pellentesque elit ullamcorper. Id aliquet risus feugiat in ante metus dictum at.</p>';
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
Use the radio buttons at the bottom of this demo module to try different layout modes. You can also change the Drawer's position and revealMode properties.
Note this demo's markup. The Drawer definition encloses the view content (the formatted text). The Drawer's own content (navigation links) is set by the template property. Finally, the toolbar markup is separate from other elements.
To get started with the DevExtreme Drawer component, refer to the following step-by-step tutorial: Getting Started with Navigation Drawer.

Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
<div class="flex-container">
<dx-toolbar [items]="toolbarContent" id="toolbar"></dx-toolbar>
<dx-drawer
[openedStateMode]="selectedOpenMode"
[position]="selectedPosition"
[revealMode]="selectedRevealMode"
template="template"
[opened]="false"
[height]="400"
[closeOnOutsideClick]="true"
>
<div *dxTemplate="let data of 'template'">
<dx-list
class="panel-list"
[hoverStateEnabled]="false"
[activeStateEnabled]="false"
[focusStateEnabled]="false"
[dataSource]="navigation"
>
</dx-list>
</div>
<div id="content" [innerHTML]="text"></div>
</dx-drawer>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<label>Opened state mode</label>
<dx-radio-group
[(value)]="selectedOpenMode"
[items]="showModes"
layout="horizontal"
>
</dx-radio-group>
</div>
<div class="option">
<label>Position</label>
<dx-radio-group
[(value)]="selectedPosition"
[items]="positionModes"
layout="horizontal"
>
</dx-radio-group>
</div>
<div *ngIf="selectedOpenMode !== 'push'" class="option">
<label>Reveal mode</label>
<dx-radio-group
[(value)]="selectedRevealMode"
[items]="showSubmenuModes"
layout="horizontal"
>
</dx-radio-group>
</div>
</div>
</div>
import {
NgModule, Component, ViewChild, enableProdMode,
} from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxListModule, DxRadioGroupModule, DxToolbarModule } from 'devextreme-angular';
import { DxDrawerComponent, DxDrawerModule, DxDrawerTypes } from 'devextreme-angular/ui/drawer';
import { List, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
})
export class AppComponent {
@ViewChild(DxDrawerComponent, { static: false }) drawer: DxDrawerComponent;
navigation: List[];
showSubmenuModes: DxDrawerTypes.RevealMode[] = ['slide', 'expand'];
positionModes: DxDrawerTypes.PanelLocation[] = ['top', 'bottom'];
showModes: DxDrawerTypes.OpenedStateMode[] = ['push', 'shrink', 'overlap'];
selectedOpenMode: DxDrawerTypes.OpenedStateMode = 'shrink';
selectedPosition: DxDrawerTypes.PanelLocation = 'top';
selectedRevealMode: DxDrawerTypes.RevealMode = 'expand';
text: string;
constructor(service: Service) {
this.text = service.getContent();
this.navigation = service.getNavigationList();
}
toolbarContent = [{
widget: 'dxButton',
location: 'before',
options: {
icon: 'menu',
stylingMode: 'text',
onClick: () => this.drawer.instance.toggle(),
},
}];
}
@NgModule({
imports: [
BrowserModule,
DxDrawerModule,
DxListModule,
DxRadioGroupModule,
DxToolbarModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .demo-container {
overflow: visible;
}
::ng-deep .flex-container {
display: flex;
flex-direction: column;
}
::ng-deep .dx-drawer-content {
display: flex;
}
::ng-deep #toolbar {
background-color: var(--dx-component-color-bg);
box-shadow: 0 2px 8px 0 rgba(0, 0, 0, 0.12), 0 2px 2px 0 rgba(0, 0, 0, 0.08);
padding: 5px 10px;
z-index: 10000;
}
::ng-deep .dx-drawer-shrink #content {
overflow: hidden;
transition: all 0.4s ease-out;
column-width: 900px;
}
::ng-deep .dx-drawer-shrink.dx-drawer-opened #content {
margin-right: -10px;
}
::ng-deep .panel-list {
height: 200px;
padding-top: 12px;
background-color: var(--dx-color-main-bg);
}
::ng-deep .panel-list .dx-list-item {
text-align: center;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
display: inline-block;
margin-right: 50px;
}
::ng-deep label {
font-weight: bold;
}
::ng-deep #content {
height: 100%;
padding: 10px 20px;
background-color: var(--dx-component-color-bg);
}
::ng-deep #content h2 {
font-size: 26px;
}
import { Injectable } from '@angular/core';
export class List {
id: number;
text: string;
}
const navigation: List[] = [
{ id: 1, text: 'Products' },
{ id: 2, text: 'Sales' },
{ id: 3, text: 'Customers' },
{ id: 4, text: 'Employees' },
{ id: 5, text: 'Reports' },
];
const text = `
<h2>
<b>Drawer Demo</b>
</h2>
<p>
Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Penatibus et magnis dis parturient. Eget dolor morbi non arcu risus. Tristique magna sit amet purus gravida quis blandit. Auctor urna nunc id cursus metus aliquam eleifend mi in. Tellus orci ac auctor augue mauris augue neque gravida. Nullam vehicula ipsum a arcu. Nullam ac tortor vitae purus faucibus ornare suspendisse sed nisi. Cursus in hac habitasse platea dictumst. Egestas dui id ornare arcu. Dictumst vestibulum rhoncus est pellentesque elit ullamcorper dignissim.</p><p>Mauris rhoncus aenean vel elit scelerisque mauris pellentesque pulvinar. Neque volutpat ac tincidunt vitae semper quis lectus. Sed sed risus pretium quam vulputate dignissim suspendisse in. Urna nec tincidunt praesent semper feugiat nibh sed pulvinar. Ultricies lacus sed turpis tincidunt id aliquet risus feugiat. Amet cursus sit amet dictum sit amet justo donec enim. Vestibulum rhoncus est pellentesque elit ullamcorper. Id aliquet risus feugiat in ante metus dictum at.
</p>
`;
@Injectable()
export class Service {
getNavigationList(): List[] {
return navigation;
}
getContent(): string {
return text;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'chart',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speed-dial-action',
'splitter',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/compiler': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
'bundles:': '../../../../bundles/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@24.1.6/cjs',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.13',
'devextreme/bundles/dx.all': 'npm:devextreme@24.1.6/bundles/dx.all.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.11',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.56',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
return acc;
}, {}),
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'tslib': 'npm:tslib@2.6.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.13/inferno/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.11/package.json',
'npm:devexpress-gantt@4.1.56/package.json',
],
};
System.config(window.config);
// System.import('@angular/compiler').catch(console.error.bind(console));
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.1.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.13.3/bundles/zone.umd.min.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
Use the radio buttons at the bottom of this demo module to try different layout modes. You can also change the Drawer's position and revealMode properties.
Note this demo's markup. The Drawer definition encloses the view content (the formatted text). The Drawer's own content (navigation links) is set by the template property. Finally, the toolbar markup is separate from other elements.
To get started with the DevExtreme Drawer component, refer to the following step-by-step tutorial: Getting Started with Navigation Drawer.

Backend API
import React, { useCallback, useMemo, useState } from 'react';
import Drawer, { type DrawerTypes } from 'devextreme-react/drawer';
import RadioGroup, { type RadioGroupTypes } from 'devextreme-react/radio-group';
import Toolbar from 'devextreme-react/toolbar';
import HTMLReactParser from 'html-react-parser';
import { text } from './data.ts';
import NavigationList from './NavigationList.tsx';
const RadioGroupOpenedOptions: DrawerTypes.OpenedStateMode[] = ['push', 'shrink', 'overlap'];
const RadioGroupRevealOptions: DrawerTypes.RevealMode[] = ['slide', 'expand'];
const RadioGroupPositionOptions: DrawerTypes.PanelLocation[] = ['top', 'bottom'];
const App = () => {
const [opened, setOpened] = useState<boolean>(false);
const [openedStateMode, setOpenedStateMode] = useState<DrawerTypes.OpenedStateMode>('shrink');
const [revealMode, setRevealMode] = useState<DrawerTypes.RevealMode>('expand');
const [position, setPosition] = useState<DrawerTypes.PanelLocation>('top');
const toolbarItems = useMemo(() => [{
widget: 'dxButton',
location: 'before',
options: {
icon: 'menu',
stylingMode: 'text',
onClick: (): void => setOpened((opened: boolean): boolean => !opened),
},
}], []);
const onOpenedStateModeChanged = useCallback(({ value }: RadioGroupTypes.ValueChangedEvent): void => {
setOpenedStateMode(value);
}, []);
const onRevealModeChanged = useCallback(({ value }: RadioGroupTypes.ValueChangedEvent): void => {
setRevealMode(value);
}, []);
const onPositionChanged = useCallback(({ value }: RadioGroupTypes.ValueChangedEvent): void => {
setPosition(value);
}, []);
const onOutsideClick = useCallback((): boolean => {
setOpened(false);
return false;
}, []);
return (
<div className="flex-container">
<Toolbar items={toolbarItems} id="toolbar" />
<Drawer
opened={opened}
closeOnOutsideClick={onOutsideClick}
openedStateMode={openedStateMode}
position={position}
component={NavigationList}
revealMode={revealMode}
height={400}
maxSize={200}
>
<div id="content">
{HTMLReactParser(text)}
</div>
</Drawer>
<div className="options">
<div className="caption">Options</div>
<div className="options-container">
<div className="option">
<label>Opened state mode</label>
<RadioGroup
items={RadioGroupOpenedOptions}
layout="horizontal"
value={openedStateMode}
onValueChanged={onOpenedStateModeChanged}
/>
</div>
<div className="option">
<label>Position</label>
<RadioGroup
items={RadioGroupPositionOptions}
layout="horizontal"
value={position}
onValueChanged={onPositionChanged}
/>
</div>
{openedStateMode !== 'push' && (
<div className="option">
<label>Reveal mode</label>
<RadioGroup
items={RadioGroupRevealOptions}
layout="horizontal"
value={revealMode}
onValueChanged={onRevealModeChanged}
/>
</div>
)}
</div>
</div>
</div>
);
};
export default App;
import React, { useCallback, useMemo, useState } from 'react';
import Drawer from 'devextreme-react/drawer';
import RadioGroup from 'devextreme-react/radio-group';
import Toolbar from 'devextreme-react/toolbar';
import HTMLReactParser from 'html-react-parser';
import { text } from './data.js';
import NavigationList from './NavigationList.js';
const RadioGroupOpenedOptions = ['push', 'shrink', 'overlap'];
const RadioGroupRevealOptions = ['slide', 'expand'];
const RadioGroupPositionOptions = ['top', 'bottom'];
const App = () => {
const [opened, setOpened] = useState(false);
const [openedStateMode, setOpenedStateMode] = useState('shrink');
const [revealMode, setRevealMode] = useState('expand');
const [position, setPosition] = useState('top');
const toolbarItems = useMemo(
() => [
{
widget: 'dxButton',
location: 'before',
options: {
icon: 'menu',
stylingMode: 'text',
onClick: () => setOpened((opened) => !opened),
},
},
],
[],
);
const onOpenedStateModeChanged = useCallback(({ value }) => {
setOpenedStateMode(value);
}, []);
const onRevealModeChanged = useCallback(({ value }) => {
setRevealMode(value);
}, []);
const onPositionChanged = useCallback(({ value }) => {
setPosition(value);
}, []);
const onOutsideClick = useCallback(() => {
setOpened(false);
return false;
}, []);
return (
<div className="flex-container">
<Toolbar
items={toolbarItems}
id="toolbar"
/>
<Drawer
opened={opened}
closeOnOutsideClick={onOutsideClick}
openedStateMode={openedStateMode}
position={position}
component={NavigationList}
revealMode={revealMode}
height={400}
maxSize={200}
>
<div id="content">{HTMLReactParser(text)}</div>
</Drawer>
<div className="options">
<div className="caption">Options</div>
<div className="options-container">
<div className="option">
<label>Opened state mode</label>
<RadioGroup
items={RadioGroupOpenedOptions}
layout="horizontal"
value={openedStateMode}
onValueChanged={onOpenedStateModeChanged}
/>
</div>
<div className="option">
<label>Position</label>
<RadioGroup
items={RadioGroupPositionOptions}
layout="horizontal"
value={position}
onValueChanged={onPositionChanged}
/>
</div>
{openedStateMode !== 'push' && (
<div className="option">
<label>Reveal mode</label>
<RadioGroup
items={RadioGroupRevealOptions}
layout="horizontal"
value={revealMode}
onValueChanged={onRevealModeChanged}
/>
</div>
)}
</div>
</div>
</div>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const navigation = [
{ id: 1, text: 'Products' },
{ id: 2, text: 'Sales' },
{ id: 3, text: 'Customers' },
{ id: 4, text: 'Employees' },
{ id: 5, text: 'Reports' },
];
export const text = '<h2><b>Drawer Demo</b></h2><p>Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Penatibus et magnis dis parturient. Eget dolor morbi non arcu risus. Tristique magna sit amet purus gravida quis blandit. Auctor urna nunc id cursus metus aliquam eleifend mi in. Tellus orci ac auctor augue mauris augue neque gravida. Nullam vehicula ipsum a arcu. Nullam ac tortor vitae purus faucibus ornare suspendisse sed nisi. Cursus in hac habitasse platea dictumst. Egestas dui id ornare arcu. Dictumst vestibulum rhoncus est pellentesque elit ullamcorper dignissim.</p><p>Mauris rhoncus aenean vel elit scelerisque mauris pellentesque pulvinar. Neque volutpat ac tincidunt vitae semper quis lectus. Sed sed risus pretium quam vulputate dignissim suspendisse in. Urna nec tincidunt praesent semper feugiat nibh sed pulvinar. Ultricies lacus sed turpis tincidunt id aliquet risus feugiat. Amet cursus sit amet dictum sit amet justo donec enim. Vestibulum rhoncus est pellentesque elit ullamcorper. Id aliquet risus feugiat in ante metus dictum at.</p>';
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'html-react-parser': 'npm:html-react-parser@1.4.14/dist/html-react-parser.min.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const navigation = [
{ id: 1, text: 'Products' },
{ id: 2, text: 'Sales' },
{ id: 3, text: 'Customers' },
{ id: 4, text: 'Employees' },
{ id: 5, text: 'Reports' },
];
export const text =
'<h2><b>Drawer Demo</b></h2><p>Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Penatibus et magnis dis parturient. Eget dolor morbi non arcu risus. Tristique magna sit amet purus gravida quis blandit. Auctor urna nunc id cursus metus aliquam eleifend mi in. Tellus orci ac auctor augue mauris augue neque gravida. Nullam vehicula ipsum a arcu. Nullam ac tortor vitae purus faucibus ornare suspendisse sed nisi. Cursus in hac habitasse platea dictumst. Egestas dui id ornare arcu. Dictumst vestibulum rhoncus est pellentesque elit ullamcorper dignissim.</p><p>Mauris rhoncus aenean vel elit scelerisque mauris pellentesque pulvinar. Neque volutpat ac tincidunt vitae semper quis lectus. Sed sed risus pretium quam vulputate dignissim suspendisse in. Urna nec tincidunt praesent semper feugiat nibh sed pulvinar. Ultricies lacus sed turpis tincidunt id aliquet risus feugiat. Amet cursus sit amet dictum sit amet justo donec enim. Vestibulum rhoncus est pellentesque elit ullamcorper. Id aliquet risus feugiat in ante metus dictum at.</p>';
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.demo-container {
overflow: visible;
}
.flex-container {
display: flex;
flex-direction: column;
}
.dx-drawer-content {
display: flex;
}
#toolbar {
background-color: var(--dx-component-color-bg);
box-shadow: 0 2px 8px 0 rgba(0, 0, 0, 0.12), 0 2px 2px 0 rgba(0, 0, 0, 0.08);
padding: 5px 10px;
z-index: 10000;
}
.dx-drawer-shrink #content {
overflow: hidden;
transition: all 0.4s ease-out;
column-width: 900px;
}
.dx-drawer-shrink.dx-drawer-opened #content {
margin-right: -10px;
}
.panel-list {
height: 200px;
padding-top: 12px;
background-color: var(--dx-color-main-bg);
}
.panel-list .dx-list-item {
text-align: center;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.options-container {
display: flex;
align-items: center;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
display: inline-block;
margin-right: 50px;
}
label {
font-weight: bold;
}
#content {
height: 100%;
padding: 10px 20px;
background-color: var(--dx-component-color-bg);
}
#content h2 {
font-size: 26px;
}
Use the radio buttons at the bottom of this demo module to try different layout modes. You can also change the Drawer's position and revealMode properties.
Note this demo's markup. The Drawer definition encloses the view content (the formatted text). The Drawer's own content (navigation links) is set by the template property. Finally, the toolbar markup is separate from other elements.
To get started with the DevExtreme Drawer component, refer to the following step-by-step tutorial: Getting Started with Navigation Drawer.